// ***
// *** CROWN OBJECT
// ***


// *###* *###* OBJECTS *###* *###*


// *** LEVEL 1 - RAW

#declare CrystalBase =
difference {
	cylinder { <0, 0, 0>, <0, 8, 0>, 16.5 texture { DARK_MET } }
	union {
		cylinder { <0, -1, 0>, <0, 9, 0>, 15.5 }
		box { <-20, -1, 0>, <20, 9, 20> }
		cylinder { <-16, 10, -20>, <-16, 10, 20>, 9 }
		cylinder { <16, 10, -20>, <16, 10, 20>, 9 }
		cylinder { <-4.5, 9, -20>, <-4.5, 9, 20>, 4.6908 }
		cylinder { <4.5, 9, -20>, <4.5, 9, 20>, 4.6908 }
		// ***
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <0, 1, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <4, 2, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <-4, 2, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <5.5, 0.5, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <-5.5, 0.5, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <8, 1, 0> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <-8, 1, 0> }
		// ***
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <6, 3, 0> }
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <-2, 3, 0> }
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> translate <-2.5, 0.5, 0> }
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, -45> translate <-6, 3, 0> }
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, -45> translate <2, 3, 0> }
		box { <-sqrt(2)/2, -sqrt(2), -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, -45> translate <2.5, 0.5, 0> }
		// ***
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> rotate <0, 90, 0> translate <0, -0.5, -13> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> rotate <0, 90, 0> translate <0, 2, -13> }
		box { <-sqrt(2)/2, -sqrt(2)/2, -20>, <sqrt(2)/2, sqrt(2)/2, 20> rotate <0, 0, 45> rotate <0, 90, 0> translate <0, 0.5, -11> }
		// ***
		sphere { <0, 0, 0>, 1 scale <1, 2, 1> translate <0, 4.5, -16> }
		// ***
		#declare i = 0
		#while (i<12)
			box { <-0.5, -3, -3>, <0.5, 3, 0>
				rotate <45, 0, 0> translate <0, -4.6908, 0> rotate <0, 0, ((15*i)-95)>
				translate <0, 0, -15.8> rotate <0, 16, 0> translate <0, 9, 0>
			}
			box { <-0.5, -3, -3>, <0.5, 3, 0>
				rotate <45, 0, 0> translate <0, -4.6908, 0> rotate <0, 0, ((15*i)-85)>
				translate <0, 0, -15.8> rotate <0, -16, 0> translate <0, 9, 0>
			}
		#declare i = i+1
		#end
		// ***
		texture { GOLD_1 }
	}
}

#declare goldenbase =
difference {
	torus { 16, 0.6 }
	box { <-20, -1, 0>, <20, 9, 20> }
}

#declare goldrings =
union {
	torus { (sqrt(3)-0.15), 0.15 rotate <90, 0, 0> scale <0.5, 1, 1> translate <0, 0, -0.5> }
	torus { (sqrt(3)-0.15), 0.15 rotate <90, 0, 0> scale <0.5, 1, 1> translate <0, 0, 0.5> }
	translate <0, 4.5, -16>
}

// *** LEVEL 2 - TEXTURES

#declare GoldenBase =
object { goldenbase texture { GOLD_1 } }

#declare GoldRings =
object { goldrings texture { GOLD_1 } }

#declare RedCrystal =
sphere { <0, 0, 0>, 0.995 scale <1, 2, 1> translate <0, 4.5, -16> texture { CRYSTAL_2 } }

// *** LEVEL 3 - ASSEMBLY

#declare KRUNA =
union {
	object { CrystalBase }
	object { GoldenBase }
	object { GoldRings }
	object { RedCrystal }
}
