// ***
// *** WATER BOWL OBJECT
// ***


// **********************************************************************************************************************

#declare bowltop =
difference {
	cylinder { <0, 0, 0>, <0, 2.5, 0>, 32.5 }
	union {
		#declare i = 0
		#while (i<6)
			box { <-50, -50, -100>, <50, 50, -30> rotate <0, (i*60), 0> }
		#declare i = i+1
		#end
		difference {
			cylinder { <0, 1, 0>, <0, 6, 0>, 28.6 }
			cylinder { <0, 0, 0>, <0, 7, 0>, 26.4 }
		}
	}
}

#declare bowlbottom =
difference {
	cylinder { <0, 0, 0>, <0, 5, 0>, 35 }
	union {
		#declare i = 0
		#while (i<6)
			box { <-50, -50, -100>, <50, 50, -22.5> rotate <0, (i*60), 0> }
		#declare i = i+1
		#end
	}
}

#declare pillar =
difference {
	cylinder { <0, -0.1, 0>, <0, 40.1, 0>, 10 texture { Mramor1 } }
	union {
		#declare i = 0
		#while (i<8)
			sphere { <0, 5, -10>, 2.5 rotate <0, (i*45), 0> texture { Mramor1 } }
			sphere { <0, 35, -10>, 2.5 rotate <0, (i*45), 0> texture { Mramor1 } }
			cylinder { <0, 5, -10>, <0, 35, -10>, 2.5 rotate <0, (i*45), 0> texture { Mramor1 } }
		#declare i = i+1
		#end
	}
}

#declare pillarbot =
difference {
	cone { <0, 0, 0>, 15, <0, 7.5, 0>, 10 }
	union {
		#declare i = 0
		#while (i<12)
			cylinder { <0, -1, 0>, <0, 11, 0>, 2.5 scale <1, 1, 2> translate <0, 0, -15> rotate <0, (i*30), 0> }
		#declare i = i+1
		#end
	}
}

#declare waterbowl =
difference {
	union {
		object { bowlbottom texture { Mramor1} }
		torus { 17.5, 2.5 translate <0, 5, 0> texture { Mramor1} }
		torus { 15, 2.5 scale <1, 2, 1> translate <0, 7.5, 0> texture { Mramor1} }
		object { pillarbot translate <0, 12.5, 0> texture { Mramor1} }
		object { pillar translate <0, 20, 0> }
		torus { 10, 2.5 scale <1, 2, 1> translate <0, 65, 0> texture { Mramor1} }
		torus { 12.5, 2.5 translate <0, 67.5, 0> texture { Mramor1} }
		difference {
			sphere { <0, 92.5, 0>, 27.5 }
			box { <-100, 95, -100>, <100, 200, 100> }
			texture { Mramor1}
		}
		torus { 27.5, 2.5 translate <0, 95, 0> texture { Mramor1} }
		object { bowltop translate <0, 95, 0> texture { Mramor1} }
	}
	union {
		sphere { <0, 97.5, 0>, 25 }
		cylinder { <0, 97.5, 0>, <0, 120, 0>, 25 }
		texture { Mramor1 }
	}
}

#declare waterinbowl =
difference {
	sphere { <0, 0, 0>, 25.5 }
	box { <-100, -2.5, -100>, <100, 50, 100> }
}

#declare goldring884 =
difference {
	cylinder { <0, 1, 0>, <0, 2.5, 0>, 28.5 }
	cylinder { <0, 0, 0>, <0, 6, 0>, 26.5 }
	texture { Iridium }
}

// **********************************************************************************************************************

#declare WaterBowl =
union {
	object { waterinbowl texture { Voda1 } translate <0, 97.5, 0> }
	object { goldring884 translate <0, 95, 0> }
	object { waterbowl }
//	box { <-40, 0, -40>, <40, 100, 40> texture { Mramor1 } }
}
